//
//  ChimpanzeeGameAppDelegate.m
//  ChimpanzeeGame
//
//  Created by kunii on 08/10/13.
//  Copyright __MyCompanyName__ 2008. All rights reserved.
//

#import "ChimpanzeeGameAppDelegate.h"
#import "ChimpanzeeGameViewController.h"
#import "FlipsideViewController.h"

@implementation ChimpanzeeGameAppDelegate

@synthesize window;
@synthesize viewController;
@synthesize flipsideNavigationBar;
@synthesize flipsideViewController;

static NSString* kStartLevel = @"StartLevel";
static NSString* kButtonSize = @"ButtonSize";

static int butonCount[] = {5,4,3}; 

- (void)applicationDidFinishLaunching:(UIApplication *)application {	
	NSUserDefaults* defaults = [NSUserDefaults standardUserDefaults];
	buttonSizeIndex = 2;
	double level = [defaults doubleForKey:kStartLevel];
	if (level == 0.0) {
		level = 0.3;
	} else {
		if (level > 1.0)	//	旧バージョンへの対応
			level = 0.3;
		buttonSizeIndex = [defaults integerForKey:kButtonSize];
	}
	[viewController setLevelRatio:level];

	[viewController setDelegate:self];
	// Override point for customization after app launch	
    [window addSubview:viewController.view];
	[window makeKeyAndVisible];

	[viewController setSize:butonCount[buttonSizeIndex] vCount:butonCount[buttonSizeIndex]];
	[viewController start:@""];						//	開始
}

- (void)applicationWillTerminate:(UIApplication *)application
{
	double level;
	if ([viewController.view superview] != nil) {
		level = [viewController getLevelRatio];
	} else {
		level = [flipsideViewController getLevelRatio];
		buttonSizeIndex = [flipsideViewController getButtonCount] * 2;
	}
	NSUserDefaults* defaults = [NSUserDefaults standardUserDefaults];
	[defaults setDouble:level forKey:kStartLevel];
	[defaults setInteger:buttonSizeIndex forKey:kButtonSize];
	[defaults synchronize];
}

- (void)dealloc {
    [viewController release];
	[window release];
	[super dealloc];
}

//	これは、「iPhoneアプリ開発、その(52)　回転終わってから始めます」の対応。
- (void)animationDidStop:(NSString*)animationID finished:(NSNumber*)finished context:(void*)context {
	if (context== nil)
		[viewController start:@""];						//	開始
}

- (IBAction)toggleView {	
	/*
	 This method is called when the info or Done button is pressed.
	 It flips the displayed view from the main view to the flipside view and vice-versa.
	 */
	if (flipsideViewController == nil) {
		[self loadFlipsideViewController];
		//	これは、「iPhoneアプリ開発、その(51)　RootViewは伊達じゃね〜んだぜ」の対応。
		//	これでビューのずれを修正する。
		flipsideViewController.view.frame = viewController.view.frame;
		CGRect frame = flipsideNavigationBar.frame;
		frame.origin = viewController.view.frame.origin;
		flipsideNavigationBar.frame = frame;
	}
	
	UIView *mainView = viewController.view;
	UIView *flipsideView = flipsideViewController.view;
	
	[UIView beginAnimations:nil context:[mainView superview]];
	//	これは、「iPhoneアプリ開発、その(52)　回転終わってから始めます」の対応。
	[UIView setAnimationDelegate:self];
	[UIView setAnimationDidStopSelector:@selector(animationDidStop:finished:context:)];
	[UIView setAnimationDuration:1];
	[UIView setAnimationTransition:([mainView superview] ? UIViewAnimationTransitionFlipFromRight : UIViewAnimationTransitionFlipFromLeft) forView:self.window cache:YES];
	
	if ([mainView superview] != nil) {
		[flipsideViewController setButtonCount:(float)buttonSizeIndex / 2.0];
		[flipsideViewController setLevelRatio:(float)[viewController getLevelRatio]];
		[flipsideViewController viewWillAppear:YES];
		[viewController viewWillDisappear:YES];
		[mainView removeFromSuperview];
		[self.window addSubview:flipsideView];
		[self.window insertSubview:flipsideNavigationBar aboveSubview:flipsideView];
		[viewController viewDidDisappear:YES];
		[flipsideViewController viewDidAppear:YES];
	} else {
		[viewController setLevelRatio:(double)[flipsideViewController getLevelRatio]];
//		buttonSizeIndex = [flipsideViewController getButtonCount] * 2;
		buttonSizeIndex = (int)([flipsideViewController getButtonCount] * 2.999);
		[viewController setSize:butonCount[buttonSizeIndex] vCount:butonCount[buttonSizeIndex]];
		[viewController viewWillAppear:YES];
		[flipsideViewController viewWillDisappear:YES];
		[flipsideView removeFromSuperview];
		[flipsideNavigationBar removeFromSuperview];
		[self.window addSubview:mainView];
		[flipsideViewController viewDidDisappear:YES];
		[viewController viewDidAppear:YES];
		//	これは、「iPhoneアプリ開発、その(52)　回転終わってから始めます」の対応。ここで呼ばない。
		//	[viewController start:@""];						//	開始
	}
	[UIView commitAnimations];
}

- (void)loadFlipsideViewController {
	
	FlipsideViewController *viewController = [[FlipsideViewController alloc] initWithNibName:@"FlipsideViewController" bundle:nil];
	self.flipsideViewController = viewController;
	[viewController release];
	
	// Set up the navigation bar
	UINavigationBar *aNavigationBar = [[UINavigationBar alloc] initWithFrame:CGRectMake(0.0, 0.0, 320.0, 44.0)];
	aNavigationBar.barStyle = UIBarStyleBlackOpaque;
	self.flipsideNavigationBar = aNavigationBar;
	[aNavigationBar release];
	
	UIBarButtonItem *buttonItem = [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemDone target:self action:@selector(toggleView)];
	UINavigationItem *navigationItem = [[UINavigationItem alloc] initWithTitle:@"flip"];
	navigationItem.rightBarButtonItem = buttonItem;
	[flipsideNavigationBar pushNavigationItem:navigationItem animated:NO];
	[navigationItem release];
	[buttonItem release];
}

@end
